#define  TAMNEU 25        /* Tamao que ocupa una neurona */
#define  TAMENTRE 15      /* Tamao que separa una neurona de otra */
#define ESC 27		  /* Tecla Escape */
#define DCHA 77		  /* Tecla flecha Derecha */
#define IZDA 75		  /* Tecla flecha  Izquierda */
#define INICIO 71	  /* Tecla Inicio */
#define FIN 79		  /* Tecla Fin */
#define LETRAA 65         /* Tecla A */
#define LETRAa 97         /* Tecla a */
#define LETRAD 68         /* Tecla D */
#define  LETRAd 100        /* Tecla d */
/*--------------------------- resaltar -------------------------------------*/

void resaltar(int x1, int y1, int x2, int y2, int colorsup, int colorinf)
{
int esquina[6];      /* Para realizar la esquina del resalte */

setfillstyle(SOLID_FILL, colorinf);
bar(x1, y1 + 3, x1 + 2, y2);
bar(x1, y2 - 2, x2 - 3, y2);
esquina[0] = x1; esquina[1] = y1;
esquina[2] = x1; esquina[3] = y1 + 3;
esquina[4] = x1 + 3; esquina[5] = y1 + 3;
fillpoly(3, esquina);
setfillstyle(SOLID_FILL, colorsup);
bar(x1 + 3, y1, x2, y1 + 2);
bar(x2 - 2, y1, x2, y2 - 3);
esquina[0] = x1; esquina[1] = y1;
esquina[2] = x1 + 3; esquina[3] = y1;
esquina[4] = x1 + 3; esquina[5] = y1 + 3;
fillpoly(3, esquina);
esquina[0] = x2 - 2; esquina[1] = y2 - 2;
esquina[2] = x2; esquina[3] = y2 - 2;
esquina[4] = x2 + 1; esquina[5] = y2 + 1;
fillpoly(3, esquina);
setfillstyle(SOLID_FILL, colorinf);
esquina[0] = x2 - 2; esquina[1] = y2 - 2;
esquina[2] = x2 - 2; esquina[3] = y2 + 1;
esquina[4] = x2 + 1; esquina[5] = y2 + 1;
fillpoly(3, esquina);
}

/*--------------------------- realstr --------------------------------------*/
void realstr(float valor, char *string, short maxstring, short decimales)
/* FINALIDAD: Pasar de un nmero real a una cadena que contenga dicho nmero,
	      con tantos decimales como diga la vble decimales. Como mximo
	      el string tendr maxstring caracteres. Si la parte entera y la
	      parte decimal no caben en el string se irn reduciendo los
	      decimales*/
{
char partedec[10],
     complemento[10];           /* Para la parte decimal */
int  entero; 	            	/* Nmero de la parte entera */
unsigned long multiplica;       /* Potencia de 10 para sacar los decimales */

entero = fabs(valor);
string[0] = '\0';
complemento[0] = '\0';
if (valor < 0)
    strcpy(string, "-\0");
itoa(entero, complemento, 10);
strcat(string, complemento);
if ((strlen(string) + decimales + 1) > maxstring)
    decimales = maxstring - strlen(string);
if (decimales > 0)
    {
    multiplica = exp(decimales *  log(10));
    if (valor < 0)
	entero = fabs((valor + entero) * multiplica);
    else
	entero = fabs((valor - entero ) * multiplica);
    partedec[0] = '\0';
    complemento[0] = '\0';
    itoa(entero, complemento, 10);
    while (strlen(complemento) < decimales)
	{
	strcat(partedec, "0\0");
	--decimales;
	}
    strcat(partedec, complemento);
    strcat(string, ".\0");
    strcat(string, partedec);
    }
}

/*--------------------------- borrar ---------------------------------------*/
void borrar(short x1, short y1, short x2, short y2, short color)
/* FINALIDAD: Borrar un rectncgulo de pantalla dado por x1, y1 , x2, y2 con
	      el color que viene dado por la vble color. */

{
setfillstyle(SOLID_FILL, color);
bar(x1, y1, x2, y2);
}

/*--------------------------- ventana --------------------------------------*/
void *ventana(int x1, int y1, int x2, int y2, char *text)
/* FINALIDAD: Esta rutina dibuja una ventana en las coordenadas: (x1, y1),
	      (x2, y2). */

{
void          *bajoventana;      /* Puntero al rea de pantalla que haba */
				 /* antes de dibujar una ventana. */

/* capturamos bajo ventana */
bajoventana = malloc(imagesize(x1, y1, x2, y2));
if (bajoventana != NULL)     /* Hay memoria suficiente */
    getimage(x1, y1, x2, y2, bajoventana);

/* realizamos el resalte */
resaltar(x1, y1, x2, y2, WHITE, DARKGRAY);

/* ponemos  el color de fondo y el titulo de la ventana */
x1 = x1 + 2 + 1;
x2 = x2 - 2 - 1;
y1 = y1 + 2 + 1;
y2 = y2 - 2 - 1;
setfillstyle(SOLID_FILL, LIGHTGRAY);
bar(x1, y1, x2, y2);
setfillstyle(SOLID_FILL, LIGHTGREEN);
x1 = x1 + (x2 - x1 - ( 8 * strlen(text) + 16)) / 2;
x2 = x1 + (8 * strlen(text)) + 16;
bar(x1, y1, x2, y1 + 14);
setcolor(BLACK);
outtextxy(x1 + 8, y1 + 4, text);
return(bajoventana);
}

/*--------------------------- errores --------------------------------------*/
void errores(char *error)
/* FINALIDAD: Dar los errores por pantalla */
{
int   x1, x2, y1, y2;    /* Coordenadas de la ventana */
void  *bajoventana;      /* Puntero al rea de pantalla que haba */
			 /* antes de dibujar una ventana */
int  longerror;         /* longitud de las letras de error en pantalla con
			   el margen */
int           salvacolor;        /* Salva el color de escritura actual. */

salvacolor = getcolor();
longerror = 8 * strlen(error) + 40;
x1 = (getmaxx() - longerror) / 2;
x2 = x1 + longerror;
y1 = (getmaxy() - 48) / 2;
y2 = y1 + 48;
bajoventana = ventana(x1, y1, x2, y2, "ERROR!");
setcolor(RED);
outtextxy(x1 + 20, y1 + 20, error);
sound(70);
delay(500);
nosound();
getch();
if (bajoventana != NULL)
    {
    putimage(x1, y1, bajoventana, COPY_PUT);
    free(bajoventana);
    }
else
    borrar(x1, y1, x2, y2, BLACK);
setcolor(salvacolor);
}

/*--------------------------- dibneurona -----------------------------------*/
void dibneurona(int x1, int y1, int x2, int y2, short color)
/*
FINALIDAD: Dibujar una neurona en una determinada posicin con un cierto
	   color y tamao
*/
{
setfillstyle(SOLID_FILL,color);
bar(x1,y1,x2,y2);
}

/*--------------------------- dibmapa --------------------------------------*/
void dibmapa(int ladomapa, VECTOR DistSal, int ganadora, VECTOR Dead, int maxx, int maxy)
/*
FINALIDAD: Dibujar el mapa de kohonen (rectangular de lado size) correspondiente
	   a un determinado patrn
*/
{

int   x1, y1,           /* Coordenadas de la ventana que contiene al mapa */
      x2, y2;
int   x1aux, y1aux;     /* Coordenadas auxiliares */

int ladoventH,		/* Tamao que ocupa el lado vertical y horizontal */
    ladoventV;          /* del mapa en pantalla */
int i, j;		/* Contadores */
int color;		/* Color de la neurona */
char textdist[10];      /* Distancia Euclidea en una cadena */
int neurona;

ladoventH = ladomapa * TAMNEU + (ladomapa + 1) * TAMENTRE;
ladoventV = ladoventH + 15;
x1 = getmaxx() - maxx + (maxx - ladoventH) / 2;
x2 = x1 + ladoventH;
y1 = getmaxy() - maxy + (maxy - ladoventV) / 2;
y2 = y1 + ladoventV;

x1aux = x1;
y1aux = y1;
ventana(x1, y1, x2, y2, "Mapa de Kohonen");
for (j = 0; j < ladomapa; ++j)
	{
	for (i = 0; i < ladomapa; ++i)
		{
		x1 = x1aux + i * (TAMENTRE+TAMNEU) + TAMENTRE;
		x2 = x1 + TAMNEU;
		y1 = y1aux + j * (TAMENTRE+TAMNEU) + TAMENTRE + 15;
		y2 = y1 + TAMNEU;
		neurona = j * ladomapa + i;
		if (neurona == ganadora)
			color = RED;
		else
			if (Dead[neurona])
				color = BLACK;
			else
				color = CYAN;
		dibneurona(x1, y1, x2, y2, color);
		realstr(DistSal[neurona], textdist, (TAMNEU + (TAMENTRE / 2)) / 10, 3);
		outtextxy(x1 - (TAMENTRE / 2), y2 + (TAMENTRE / 3), textdist);
		}
	}
}

/*--------------------------- dibiterciones --------------------------------*/
void dibiteraciones(int Niteraciones, int iteracion, float eta)
/*
FINALIDAD: Dibujar por pantalla las iteraciones  y el valor de eta
*/
{
int   x1, y1,            /* Coordenadas de la ventana */
      x2, y2;
char text[100];          /* Texto  a imprimir */
char textaux[10];
int color;

x1 = 10;
y1 = 10;
x2 = x1 + 370;
y2 = y1 + 55;

text[0] = '\0';
strcat(text, "Interacion ");
itoa(iteracion, textaux, 10);
strcat(text, textaux);
strcat(text, " con un valor de Eta= ");
realstr(eta, textaux, 6, 4);
strcat(text, textaux);
ventana(x1, y1, x2, y2, "Report");
if (Niteraciones == 1)
	outtextxy(x1+10, y1+25, "Testeando...");
else
	outtextxy(x1+10, y1+25, "Entrenando...");
outtextxy(x1+10, y1+40, text);
}

/*--------------------------- dibcontrol -----------------------------------*/
void dibcontrol(int Npatrones, int ladomapa, MATRIX Out2, MATRIX DistEuclidea, VECTOR Ganadoras, VECTOR Dead)
/*
FINALIDAD: Dibujar el panel de control y realizar dicho control.
*/
{
int   x1, y1,            /* Coordenadas de la ventana que contiene al mapa */
      x2, y2;
char textpatron[10];    /* N de patrn pero en texto */
short salir;		/* 1 = salir del Panel del control */
int patron;             /* N de patrn */
char tecla;
int color;
short numeros = 0; 	/* 0 = Se visualiza acitvacin */
			/* 1 = En otro caso distancia Euclidea */

x1 = 400;
y1 = 10;
x2 = x1 + 180;
y2 = y1 + 80;
ventana(x1, y1, x2, y2, "Panel de Control");
outtextxy(x1+10, y1+25, "N de patrn: ");
color = getcolor();
setcolor(WHITE);
borrar(x1+8,y1+38, x1+26, y1+48, RED);
outtextxy(x1+10, y1+40, "<-");
borrar(x1+34,y1+38, x1+52, y1+48, RED);
outtextxy(x1+36, y1+40, "->");
borrar(x1+56,y1+38, x1+106, y1+48, RED);
outtextxy(x1+58, y1+40, "Inicio");
borrar(x1+114,y1+38, x1+140, y1+48, RED);
outtextxy(x1+116, y1+40, "Fin");
borrar(x1+8,y1+53, x1+34, y1+63, RED);
outtextxy(x1+10,y1+55, "Esc");
borrar(x1+85,y1+53, x1+95, y1+63, BLUE);
outtextxy(x1+87,y1+55, "D");
setcolor(YELLOW);
borrar(x1+70,y1+53, x1+80, y1+63, BLUE);
outtextxy(x1+72,y1+55, "A");

setcolor(color);

patron = 0;
salir = 0;

do
	{
	itoa(patron + 1, textpatron, 10);
	borrar(x1+118,y1+23, x1+ 160, y1+33, LIGHTGRAY);
	borrar(x1+118,y1+23, x1+ 118 + strlen(textpatron) * 8, y1+33, BLUE);
	color = getcolor();
	setcolor(WHITE);
	outtextxy(x1+120, y1+25, textpatron);
	setcolor(color);
	if (numeros == 0)
		dibmapa(ladomapa, Out2[patron], Ganadoras[patron], Dead, getmaxx(), getmaxy() - y2);
	else
		dibmapa(ladomapa, DistEuclidea[patron], Ganadoras[patron], Dead, getmaxx(), getmaxy() - y2);
	tecla = getch();
	switch (tecla)
		{
		case ESC: salir = 1;
			  break;
		case 0: switch (getch())
				{
				case DCHA: patron = (patron + 1) % Npatrones;
					   break;
				case IZDA: --patron;
					   if (patron < 0)
						patron = Npatrones - 1;
					   break;
				case INICIO: patron = 0;
					     break;
				case FIN: patron = Npatrones - 1;
					  break;
				}
			break;
		case LETRAA:
		case LETRAa:
			    color = getcolor();
			    setcolor(WHITE);
			    outtextxy(x1+87,y1+55, "D");
			    setcolor(YELLOW);
			    outtextxy(x1+72,y1+55, "A");
			    numeros = 0;
			    setcolor(color);
			    break;
		case LETRAD:
		case LETRAd:
			    color = getcolor();
			    setcolor(YELLOW);
			    outtextxy(x1+87,y1+55, "D");
			    setcolor(WHITE);
			    outtextxy(x1+72,y1+55, "A");
			    numeros = 1;
			    setcolor(color);
			    break;
		}
	}
while (! salir);
borrar(x1,y1,x2,y2, BLACK);
borrar(1, 100, getmaxx(), getmaxy(), BLACK);
}